Bug 136764 - Style inspector: No scrollbars and minimum width
Summary: Style inspector: No scrollbars and minimum width
Status: NEW
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: Writer (show other bugs)
Version:
(earliest affected)
7.1.0.0.alpha0+
Hardware: All Windows (All)
: medium normal
Assignee: Not Assigned
URL:
Whiteboard: target:7.2.0
Keywords:
: 139360 143185 144044 (view as bug list)
Depends on:
Blocks: Style-Inspector
  Show dependency treegraph
 
Reported: 2020-09-15 06:57 UTC by Thomas Lendo
Modified: 2021-11-30 00:31 UTC (History)
15 users (show)

See Also:
Crash report or crash signature:
Regression By:


Attachments
Screenshot of the LongTextVisualGlitch (7.31 KB, image/png)
2021-04-17 09:30 UTC, bugzilla2
Details
Screenshot of doubled horizontal Scrollbars (2.03 KB, image/png)
2021-04-17 09:46 UTC, bugzilla2
Details
Screencast on Windows (1.71 MB, image/gif)
2021-04-19 12:53 UTC, Mike Kaganski
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Thomas Lendo 2020-09-15 06:57:24 UTC
The styles inspector (at least on Windows) shows no vertical or horizontal scrollbars despite it's needed. You can scroll down with the mouse but the view doesn't change and no scrollbars are available.

The minimum width of the styles inspector dock of the sidebar changes according to the longest value that is shown in the inspector. So, if you click in a formatted text and then change the sidebar width, there is a minimum width and the sidebar "snaps" to it and it can't be made smaller. After you click to another text with different formatting and longer or shorter values in the inspector, then you can change the width of the sidebar but only until it "snaps" to the new width.

This minimum width according to value length is suspicious. Funny is that you can change the width of the Properties column in the style inspector and also the Values column, but this has no effect to the above mentioned minimum width. Better is to have the same behavior as the styles deck of the sidebar (a small miminum width but it's to the user how big the sidebar should be).

Version: 7.1.0.0.alpha0+ (x64)
Build ID: abcc4eb907661e07ad850ccce7eb06f129da4286
CPU threads: 12; OS: Windows 10.0 Build 18363; UI render: Skia/Vulkan; VCL: win
Locale: de-AT (de_AT); UI: de-DE
Comment 1 Mike Kaganski 2020-09-21 06:47:04 UTC
Confirmed with Version: 7.1.0.0.alpha0+ (x64)
Build ID: c6b6995004d34cadaec68e2b6e17667d43f9995e
CPU threads: 12; OS: Windows 10.0 Build 19041; UI render: Skia/Raster; VCL: win
Locale: en-US (ru_RU); UI: en-US
Calc: CL
Comment 2 John 2020-11-22 12:20:33 UTC
My issue may be the same as this, or at least a subset of it. I routinely have the sidebar open to show styles and formatting but only need to see part of the style name to be able to recognise and select it. To save screen space, I narrow down the sidebar so that just the first few letters of the style name is showing. This is no longer possible in LibreOffice 7 - there is a minimum size below which it cannot be narrowed and which is far more than I need with wasted space ++ on smaller screens.
Comment 3 Ming Hua 2020-12-02 23:20:29 UTC
Style Inspector in sidebar is still not scroll-able in 7.1.0 Beta1 on Windows 10.

No scrollbar, wheel on mouse does nothing, selecting an item and press down arrow key doesn't scroll and just select items out of view.  IMHO this makes Style Inspector not usable for any serious task on Windows, and is not really suitable to be brought out of experimental feature (it leaves a bad first impression to users).

Version: 7.1.0.0.beta1 (x64)
Build ID: 828a45a14a0b954e0e539f5a9a10ca31c81d8f53
CPU threads: 2; OS: Windows 10.0 Build 18363; UI render: Skia/Raster; VCL: win
Locale: zh-CN (zh_CN); UI: zh-CN
Calc: threaded
Comment 4 Ming Hua 2020-12-02 23:25:19 UTC
Hi John,

(In reply to John from comment #2)
> My issue may be the same as this, or at least a subset of it. I routinely
> have the sidebar open to show styles and formatting but only need to see
> part of the style name to be able to recognise and select it.
This "style inspector" may sound like what you use, but it isn't -- it's a new feature in 7.1, and not available in version 7.0.x or earlier (unless you enable experimental features, and even then it's very different from what 7.1 has).

You were using the "Styles" sidebar, which is not related to this bug.  So it would be better if you un-CC from this bug and report a new one about your problems.
Comment 5 John 2020-12-03 12:23:47 UTC
(In reply to Ming Hua from comment #4)
> Hi John,
> 
> (In reply to John from comment #2)
> > My issue may be the same as this, or at least a subset of it. I routinely
> > have the sidebar open to show styles and formatting but only need to see
> > part of the style name to be able to recognise and select it.
> This "style inspector" may sound like what you use, but it isn't -- it's a
> new feature in 7.1, and not available in version 7.0.x or earlier (unless
> you enable experimental features, and even then it's very different from
> what 7.1 has).
> 
> You were using the "Styles" sidebar, which is not related to this bug.  So
> it would be better if you un-CC from this bug and report a new one about
> your problems.

Thank you for pointing my error out. I had a look at 7.1.0 beta 1 with style inspector activated and it is immediately apparent that scrollbars, especially vertical, are essential but missing.
Comment 6 Raúl 2020-12-27 11:16:29 UTC
The sidebar still "snaps" to some minimum width (as reported by Thomas and John). In my case I am running in libreoffice 7.1.0.1 rc in Ubuntu 20.04. This minimum width is too large; most of the sidebar is filled with empty space. In libreoffice impress this is especially problematic as it makes editing slides very uncomfortable: the width left for the slides is very reduced as compared to previous editions of libreoffice. I think the user should be able to adjust the width of the sidebar and the width should be fixed independently of the selected objects.
Comment 7 Ming Hua 2020-12-28 10:04:32 UTC
(In reply to Raúl from comment #6)
> The sidebar still "snaps" to some minimum width (as reported by Thomas and
> John). In my case I am running in libreoffice 7.1.0.1 rc in Ubuntu 20.04.
> This minimum width is too large; most of the sidebar is filled with empty
> space. In libreoffice impress this is especially problematic as it makes
> editing slides very uncomfortable: the width left for the slides is very
> reduced as compared to previous editions of libreoffice. I think the user
> should be able to adjust the width of the sidebar and the width should be
> fixed independently of the selected objects.
This bug is about Style Inspector in Writer specifically, not any other sidebar, and definitely not sidebars in Impress.

Please file separate bug for your problem.

And please don't change version field of an existing bug just because you see the same bug in that version, it's supposed to be "the earliest affected version", also see https://wiki.documentfoundation.org/QA/Bugzilla/Fields/Version#How_we_use_this_field .
Comment 8 Ming Hua 2021-01-01 21:55:00 UTC
*** Bug 139360 has been marked as a duplicate of this bug. ***
Comment 9 bugzilla2 2021-01-20 17:43:43 UTC
Not sure if I shall post it here or create a new bug. lets try it here first...

My issue with the styles inspector is not about scrollbars, but about being to wide and not resizable. All the other sidebar elements are resizable, but the styles inspector is not. But it should be, as it is using to much space.
Comment 10 V Stuart Foote 2021-04-13 19:30:28 UTC
@Heiko, the other SB decks are recently behaving better for minimum size and resize, but the Styles Inspector is just too wide. Made worse on Windows when the os/DE is scaled (bug 128243).

What needs to happen to bring it in line with the other SB decks?

And, still seem to need scroll bars when the deck gets fully populated on a complex document.
Comment 11 Heiko Tietze 2021-04-14 12:21:37 UTC
(In reply to V Stuart Foote from comment #10)
> What needs to happen to bring it in line with the other SB decks?

https://gerrit.libreoffice.org/c/core/+/114088

No idea about the scrollbars, works for me on Linux.
Comment 12 Commit Notification 2021-04-16 08:46:54 UTC
Heiko Tietze committed a patch related to this issue.
It has been pushed to "master":

https://git.libreoffice.org/core/commit/0255a3f1704e50c478bd9a9e3e389a5e1f23ae81

Related tdf#136764 - Minimum width for Styles Inspector

It will be available in 7.2.0.

The patch should be included in the daily builds available at
https://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
https://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 13 Heiko Tietze 2021-04-17 08:55:38 UTC
Mike, got a report that scrollbars are not present on Windows. Can you confirm/any idea how to resolve?
Comment 14 bugzilla2 2021-04-17 09:15:33 UTC
On my machine the patch is working. Width of the Styles-Inspector is a lot less than before, and I do have scrollbars.

Version: 7.2.0.0.alpha0+ (x64) / LibreOffice Community
Build ID: 2f509fce90a29b7c35910b670fb79a6e2b72ba7b
CPU threads: 12; OS: Windows 10.0 Build 18363; UI render: Skia/Vulkan; VCL: win
Locale: de-DE (de_DE); UI: de-DE
Calc: CL
Comment 15 bugzilla2 2021-04-17 09:30:19 UTC
Created attachment 171249 [details]
Screenshot of the LongTextVisualGlitch
Comment 16 bugzilla2 2021-04-17 09:33:44 UTC
But there is another Problem in StylesInspector (SO):

Long words are "faded out" before they reach the end of the row, but than continued in the next row. See attached Screenshot. So, long words to have a gap, which looks odd.

None of the bugreports in the META seem to address this "problem", so I added it here.
Comment 17 Mike Kaganski 2021-04-17 09:37:28 UTC
(In reply to Heiko Tietze from comment #13)
> Mike, got a report that scrollbars are not present on Windows. Can you
> confirm/any idea how to resolve?

Yes I can confirm. After your patch, the horizontal scrollbar is visible, and that allows one to scroll right to reveal the vertical scrollbar that is initially hidden outside of the frame. It looks like the scrollbars are at different nested frames, which is very awkward.

Is it different with gen?

By the way, the new object inspector also has similar scrollbars problems.

It seems that the complex layout of the panels are created at random, using trial and error with some hacks to finally do the right thing, instead of using some simple layout that would automatically make it work out of the box. But it's just a guess, and I don't know much about the machinery.
Comment 18 bugzilla2 2021-04-17 09:46:53 UTC
Created attachment 171250 [details]
Screenshot of doubled horizontal Scrollbars

@comment #13:

This is correct, there seems to be nested scrollbars. In this screenshot you can see a high scrollbar at the bottom, and a very flat scrollbar above, which is the actual scrollbar for the SI. The bigger scrollbar element only moves the whole frame a few pixels.
Comment 19 Heiko Tietze 2021-04-17 10:09:02 UTC
One of the two scrollbars might disappear when you shrink the second column. But I don't see it on Linux, neither with Qt or gen. 

Reported the text-in-second-column issue in bug 141721.
Comment 20 bugzilla2 2021-04-17 10:25:18 UTC
(In reply to Heiko Tietze from comment #19)
> One of the two scrollbars might disappear when you shrink the second column.

On my system, the size of the inner scrollbars stays the same, no matter how narrow I make the columns. At least at first.

BUT: If I fold/unfold the "default paragraph style", with narrow columns, the inner scrollbar disappears.

So it seems to need a fold/unfold-operation to recalculate the inner-box-size.

Nevertheless, I don't think there should be nested scrollbars. And if it's not possible to remove the doubled scrollbars, the inner scrollbar should be bigger at least, because currently its hard to grab because its so flat.
Comment 21 Mike Kaganski 2021-04-19 12:53:45 UTC
Created attachment 171287 [details]
Screencast on Windows

On the screencast, one may see multiple problems:

1. The two horizontal scrollbars at the bottom of the Style Inspector, suggesting that the minimum size of the inner frame of the Inspector is greater than the space for it provided by the minimal-width outer frame.
2. The two frames are visible (there's a "bevel" between the outer frame and the inner one, with the list: it is just a waste of time, with two bevels also making it look odd visually).
3. The inner horizontal scrollbar is obviously wrong: it appears when it all fits to the control, and even there's more space left.
4. The other inspector (Object Inspector) also shows a problem, when resizing SI makes its left panel disappear, and it will not re-appear.
5. Object Inspector's vertical scrollbar goes below the bottom border of the Inspector, so that its bottom arrow is invisible.

A mess.
Comment 22 Dieter 2021-06-09 07:55:51 UTC
(In reply to Mike Kaganski from comment #21)
> Created attachment 171287 [details]
> Screencast on Windows
> 
> On the screencast, one may see multiple problems:

So it would be godd to have separate bug reports.
Comment 23 Dieter 2021-07-19 06:45:46 UTC
*** Bug 143185 has been marked as a duplicate of this bug. ***
Comment 24 [REDACTED] 2021-08-24 10:36:33 UTC
*** Bug 144044 has been marked as a duplicate of this bug. ***